## iem-plugin-suite 1.13.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13)

#  _____ ______ __  __   _____  _                    _          _____       _ _
# |_   _|  ____|  \/  | |  __ \| |                  (_)        / ____|     (_) |
#   | | | |__  | \  / | | |__) | |_   _  __ _        _ _ __   | (___  _   _ _| |_ ___
#   | | |  __| | |\/| | |  ___/| | | | |/ _` |______| | '_ \   \___ \| | | | | __/ _ \
#  _| |_| |____| |  | | | |    | | |_| | (_| |______| | | | |  ____) | |_| | | ||  __/
# |_____|______|_|  |_| |_|    |_|\__,_|\__, |      |_|_| |_| |_____/ \__,_|_|\__\___|
#                                        __/ |
#                                       |___/


# The following list will hold all the plug-ins which will be built.
# Simply comment them out if you want to build only a subset of the plug-ins.
set (PLUGINS_TO_BUILD
        AllRADecoder
        BinauralDecoder
        CoordinateConverter
        DirectionalCompressor
        DirectivityShaper
        DistanceCompensator
        DualDelay
        EnergyVisualizer
        FdnReverb
        MatrixMultiplier
        MultiBandCompressor
        MultiEncoder
        MultiEQ
        OmniCompressor
        ProbeDecoder
        RoomEncoder
        SceneRotator
        SimpleDecoder
        StereoEncoder
        ToolBox
    )

# The following options let you select the plug-ins formats you want to build.
# You can either change them here or use the command line to switch them on/off.
option (IEM_BUILD_VST2 "Build VST2 version of the plug-ins." OFF)
option (IEM_BUILD_VST3 "Build VST3 version of the plug-ins." ON)
option (IEM_BUILD_STANDALONE "Build standalones of the plug-ins." OFF)
option (IEM_STANDALONE_JACK_SUPPORT "Build standalones with JACK support." ON)


set (CMAKE_POSITION_INDEPENDENT_CODE ON)

# Actual project configuration
project (IEMPluginSuite VERSION 1.12.1 LANGUAGES C CXX)

set_property (GLOBAL PROPERTY USE_FOLDERS YES)
set_directory_properties (PROPERTIES JUCE_COPY_PLUGIN_AFTER_BUILD ON)

# set copy paths for built plug-ins
if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    set_directory_properties (PROPERTIES JUCE_VST_COPY_DIR "$ENV{HOME}/Library/Audio/Plug-Ins/VST/IEM")
    set_directory_properties (PROPERTIES JUCE_VST3_COPY_DIR "$ENV{HOME}/Library/Audio/Plug-Ins/VST3/IEM")

elseif (CMAKE_SYSTEM_NAME STREQUAL "Windows")
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set_directory_properties (PROPERTIES JUCE_VST_COPY_DIR "$ENV{ProgramW6432}/Steinberg/Vstplugins/IEM")
        set (prefix "$ENV{CommonProgramW6432}")
    else()
        set_directory_properties (PROPERTIES JUCE_VST_COPY_DIR "$ENV{programfiles\(x86\)}/Steinberg/Vstplugins/IEM")
        set (prefix "$ENV{CommonProgramFiles\(x86\)}")
    endif()
    set_directory_properties (PROPERTIES JUCE_VST3_COPY_DIR "${prefix}/VST3/IEM")

elseif ((CMAKE_SYSTEM_NAME STREQUAL "Linux") OR (CMAKE_SYSTEM_NAME MATCHES ".*BSD"))
    set_directory_properties (PROPERTIES JUCE_VST_COPY_DIR "$ENV{HOME}/.vst/IEM")
    set_directory_properties (PROPERTIES JUCE_VST3_COPY_DIR "$ENV{HOME}/.vst3/IEM")
endif()

# add JUCE dependency
add_subdirectory (JUCE)

# formats
set (IEM_FORMATS "")

if (IEM_BUILD_VST2)
    message ("-- IEM: Building VST2 versions")
    list (APPEND IEM_FORMATS VST)
    # checking VST2 SDK
    if (DEFINED VST2SDKPATH)
        juce_set_vst2_sdk_path (${VST2SDKPATH})
    else()
        message (FATAL_ERROR "You have to specify the VST2PATH variable with the path to the VST2 SDK if you want to build VST2 versions.")
    endif()
endif()

if (IEM_BUILD_VST3)
    message ("-- IEM: Building VST3 versions")
    list (APPEND IEM_FORMATS VST3)
endif()

if (IEM_BUILD_STANDALONE)
    message ("-- IEM: Building Standalone versions")
    list (APPEND IEM_FORMATS Standalone)
endif()

include_directories (resources/ /usr/local/include)
add_compile_definitions (DONT_SET_USING_JUCE_NAMESPACE=1
                         JUCE_MODAL_LOOPS_PERMITTED=1)

juce_add_binary_data (LAF_fonts SOURCES
    resources/lookAndFeel/Roboto-Bold.ttf
    resources/lookAndFeel/Roboto-Light.ttf
    resources/lookAndFeel/Roboto-Medium.ttf
    resources/lookAndFeel/Roboto-Regular.ttf)

foreach (subproject IN LISTS PLUGINS_TO_BUILD)
    add_subdirectory (${subproject})
endforeach()


# link fftw if necessary, only needed by BinauralDecoder, and not on macOS
if (BinauralDecoder IN_LIST PLUGINS_TO_BUILD AND NOT CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    if (CMAKE_SYSTEM_NAME STREQUAL "Windows") # build fftw3f on windows
        set (BUILD_SHARED_LIBS OFF)
        set (BUILD_TESTS OFF)
        set (ENABLE_FLOAT ON)
        set (ENABLE_SSE ON)

        set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
        add_subdirectory (fftw)
        set_target_properties ("fftw3f" PROPERTIES POSITION_INDEPENDET_CODE ON)
    endif()

    target_compile_definitions ("BinauralDecoder" PUBLIC JUCE_DSP_USE_STATIC_FFTW=1)
    target_link_libraries ("BinauralDecoder" PRIVATE fftw3f)
endif()


if (IEM_BUILD_STANDALONE)
    foreach (subproject IN LISTS PLUGINS_TO_BUILD)
        target_sources(${subproject} PRIVATE
            resources/Standalone/StandaloneApp.cpp
            resources/Standalone/MyStandaloneFilterWindow.h
            resources/Standalone/IEM_JackAudio.h
            resources/Standalone/IEM_AudioDeviceSelectorComponent.cpp
            resources/Standalone/IEM_AudioDeviceSelectorComponent.h)
    endforeach()

    if (NOT IEM_STANDALONE_JACK_SUPPORT)
        foreach (subproject IN LISTS PLUGINS_TO_BUILD)
            target_compile_definitions(${subproject} PUBLIC DONT_BUILD_WITH_JACK_SUPPORT=1)
        endforeach()
    endif()
endif()

=== Makefile ===
default: all

# list of projects
ALL_PROJECTS=$(patsubst %/, %, $(dir $(wildcard */*.jucer)))
PROJECTS=$(filter-out _PluginTemplate, $(ALL_PROJECTS))

# what do we want to build: Standalone, VST; all
## currently this has only an effect on the Linux buildsystem
TARGET=all

# select configuration: Release or Debug
CONFIG = Release

# helper applications
PROJUCER=Projucer


# how many parallel builds we want
#PARALLEL = 1
PARALLEL =

remove_intermediates = no

# the buildsystem we are using
# possible values: LinuxMakefile XCode
uname := $(shell uname)

ifeq ($(findstring $(uname), Linux GNU GNU/kFreeBSD), $(uname))
  BUILDSYSTEM = LinuxMakefile
endif

ifeq ($(findstring MSYS, $(uname)), MSYS)
  BUILDSYSTEM = VS2017
endif

ifeq ($(uname), Darwin)
  BUILDSYSTEM = XCode
endif


# generic buildflags
buildflags =

ifeq ($(BUILDSYSTEM), VS2017)
  WINBITS = $(BITS)
  ifeq ($(WINBITS), )
    WINBITS = 64
  endif
  WINTARGET = Release $(WINBITS)bit
  WINPLATFORM = x64
  ifeq ($(CONFIG)$(WINBITS), Release32)
    WINPLATFORM = win32
  endif
  ifeq ($(CONFIG), Debug)
    WINPLATFORM = x64
    WINTARGET = Debug
  endif
  buildflags += -nologo
endif

# if no CPU is requested, use the defaults
numcpus = $(strip $(PARALLEL))
ifeq ($(strip $(numcpus)),)
  numcpus = 0
endif
ifeq ($(strip $(numcpus)), 0)
  numcpus = <default>
  ifeq ($(BUILDSYSTEM), VS2017)
    buildflags += -maxcpucount
  endif
else
  ifeq ($(BUILDSYSTEM), LinuxMakefile)
    buildflags += -j$(numcpus)
  endif
  ifeq ($(BUILDSYSTEM), VS2017)
    buildflags += -maxcpucount:$(numcpus)
  endif
  ifeq ($(BUILDSYSTEM), XCode)
    buildflags += -IDEBuildOperationMaxNumberOfConcurrentCompileTasks=$(numcpus)
  endif
endif

.PHONY: system
system:
	@echo "uname : $(uname)"
	@echo "system: $(BUILDSYSTEM)"
	@echo "config: $(CONFIG)"
ifeq ($(BUILDSYSTEM), VS2017)
	@echo "VS2017: $(WINTARGET) | $(WINPLATFORM)"
endif
ifneq ($(numcpus),)
	@echo "CPUs  : $(numcpus)"
endif
ifneq ($(strip $(buildflags)),)
	@echo "xflags: $(buildflags)"
endif

.PHONY: showprojects
showprojects:
	@echo $(PROJECTS)

.PHONY: $(ALL_PROJECTS)
$(ALL_PROJECTS): % : %-$(BUILDSYSTEM)-build

# generic rules
.PHONY: distclean clean all resave

noop=
space=$(noop) $(noop)
vpath %.jucer $(subst $(space),:,$(ALL_PROJECTS))

all: $(PROJECTS:%=%-$(BUILDSYSTEM)-build)
clean: $(PROJECTS:%=%-$(BUILDSYSTEM)-clean)
distclean:
	rm -rf */Builds
resave: $(PROJECTS:%=%/Builds/LinuxMakefile/Makefile)
# aliases
.PHONY: $(ALL_PROJECTS:%=%-build)
.PHONY: $(ALL_PROJECTS:%=%-clean)
$(ALL_PROJECTS:%=%-build): %-build : %-$(BUILDSYSTEM)-build
$(ALL_PROJECTS:%=%-clean): %-clean : %-$(BUILDSYSTEM)-clean

# LinuxMakefile based rules
%-LinuxMakefile-build: %/Builds/LinuxMakefile/Makefile
	make $(buildflags) \
		-C $(<D) \
		CONFIG="$(CONFIG)" \
		$(TARGET)
ifeq ($(remove_intermediates), yes)
	rm -rf $(<D)/build/intermediate/
endif
%-LinuxMakefile-clean: %/Builds/LinuxMakefile/Makefile
	make -C $(<D) \
		CONFIG="$(CONFIG)" \
		clean
%/Builds/LinuxMakefile/Makefile: %.jucer
	$(PROJUCER) --resave "$^"

# XCode based rules
.SECONDEXPANSION:
%-XCode-build: $$(subst @,%,@/Builds/MacOSX/@.xcodeproj/project.pbxproj)
	xcodebuild $(buildflags) \
		-project $(<D) \
		-target "$(firstword $(subst /, ,$<)) - All" \
		-configuration "$(CONFIG)" \
		build
	find $(<D)/../
%-XCode-clean: $$(subst @,%,@/Builds/MacOSX/@.xcodeproj/project.pbxproj)
	xcodebuild \
		-project $(<D) \
		-target "$(firstword $(subst /, ,$<)) - All" \
		-configuration "$(CONFIG)" \
		clean
# this does not declare a proper dependency,
# so Projucer will be called for each %-build
%.pbxproj:
	$(PROJUCER) --resave $(subst @,$(firstword $(subst /, ,$@)),@/@.jucer)


# VS2017 based rules
# TODO: find out how to pass CONFIG and TARGET
%-VS2017-build: $$(subst @,%,@/Builds/VisualStudio2017/@.sln)
	MSBuild.exe $(buildflags) \
		-p:Configuration="$(WINTARGET)",Platform=$(WINPLATFORM) \
		$<
	find $(<D)/
%-VS2017-clean: $$(subst @,%,@/Builds/VisualStudio2017/@.sln)
	MSBuild.exe \
		-p:Configuration="$(WINTARGET)",Platform=$(WINPLATFORM) \
		-t:Clean \
		$<
# this does not declare a proper dependency,
# so Projucer will be called for each %-build
%.sln:
	$(PROJUCER) --resave $(subst @,$(firstword $(subst /, ,$@)),@/@.jucer)

=== AllRADecoder/CMakeLists.txt ===

juce_add_plugin (AllRADecoder
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE AlRa
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "AllRADecoder"
    FORMATS ${IEM_FORMATS}
    VERSION "0.9.2")


juce_generate_juce_header (AllRADecoder)

target_sources (AllRADecoder PRIVATE
    Source/AmbisonicNoiseBurst.h
    Source/EnergyDistributionVisualizer.h
    Source/LoudspeakerTableComponent.h
    Source/LoudspeakerVisualizer.h
    Source/NoiseBurst.h
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h
    Source/RotateWindow.h
    Source/tDesign5200.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/NewtonApple/NewtonApple_hull3D.h
    ../resources/NewtonApple/NewtonApple_hull3D.cpp

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (AllRADecoder PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (AllRADecoder PRIVATE Source)

target_link_libraries (AllRADecoder PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== BinauralDecoder/CMakeLists.txt ===

juce_add_plugin (BinauralDecoder
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE BiDe
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "BinauralDecoder"
    FORMATS ${IEM_FORMATS}
    VERSION "0.6.3")


juce_generate_juce_header(BinauralDecoder)

target_sources (BinauralDecoder PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (BinauralDecoder PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (BinauralDecoder PRIVATE Source)


juce_add_binary_data (BinauralDecoderEQs
    HEADER_NAME "EQData.h"
    NAMESPACE EQData
    SOURCES
        Source/EQ/AKG-K141MK2.wav
        Source/EQ/AKG-K240DF.wav
        Source/EQ/AKG-K240MK2.wav
        Source/EQ/AKG-K271MK2.wav
        Source/EQ/AKG-K271STUDIO.wav
        Source/EQ/AKG-K601.wav
        Source/EQ/AKG-K701.wav
        Source/EQ/AKG-K702.wav
        Source/EQ/AKG-K1000-Closed.wav
        Source/EQ/AKG-K1000-Open.wav
        Source/EQ/AudioTechnica-ATH-M50.wav
        Source/EQ/Beyerdynamic-DT250.wav
        Source/EQ/Beyerdynamic-DT770PRO-250Ohms.wav
        Source/EQ/Beyerdynamic-DT880.wav
        Source/EQ/Beyerdynamic-DT990PRO.wav
        Source/EQ/Presonus-HD7.wav
        Source/EQ/Sennheiser-HD430.wav
        Source/EQ/Sennheiser-HD560ovationII.wav
        Source/EQ/Sennheiser-HD480.wav
        Source/EQ/Sennheiser-HD565ovation.wav
        Source/EQ/Sennheiser-HD600.wav
        Source/EQ/Sennheiser-HD650.wav
        Source/EQ/SHURE-SRH940.wav)

juce_add_binary_data (BinauralDecoderIRs
    HEADER_NAME "IRData.h"
    NAMESPACE IRData
    SOURCES
        Source/IRs/irsOrd1.wav
        Source/IRs/irsOrd7.wav
        Source/IRs/irsOrd6.wav
        Source/IRs/irsOrd5.wav
        Source/IRs/irsOrd4.wav
        Source/IRs/irsOrd3.wav
        Source/IRs/irsOrd2.wav)

target_link_libraries (BinauralDecoder PRIVATE
    LAF_fonts
    BinauralDecoderEQs
    BinauralDecoderIRs
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== CoordinateConverter/CMakeLists.txt ===

juce_add_plugin (CoordinateConverter
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE CoCo
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "CoordinateConverter"
    FORMATS ${IEM_FORMATS}
    VERSION "0.4.3")


juce_generate_juce_header (CoordinateConverter)

target_sources (CoordinateConverter PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (CoordinateConverter PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (CoordinateConverter PRIVATE Source)

target_link_libraries (CoordinateConverter PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== DirectionalCompressor/CMakeLists.txt ===

juce_add_plugin (DirectionalCompressor
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE DiCo
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "DirectionalCompressor"
    FORMATS ${IEM_FORMATS}
    VERSION "1.3.3")


juce_generate_juce_header (DirectionalCompressor)

target_sources (DirectionalCompressor PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (DirectionalCompressor PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (DirectionalCompressor PRIVATE Source)

target_link_libraries (DirectionalCompressor PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== DirectivityShaper/CMakeLists.txt ===

juce_add_plugin (DirectivityShaper
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE DiSh
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "DirectivityShaper"
    FORMATS ${IEM_FORMATS}
    VERSION "0.8.3")


juce_generate_juce_header (DirectivityShaper)

target_sources (DirectivityShaper PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (DirectivityShaper PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (DirectivityShaper PRIVATE Source)

target_link_libraries (DirectivityShaper PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== DistanceCompensator/CMakeLists.txt ===

juce_add_plugin (DistanceCompensator
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE DiCo
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "DistanceCompensator"
    FORMATS ${IEM_FORMATS}
    VERSION "0.3.3")


juce_generate_juce_header (DistanceCompensator)

target_sources (DistanceCompensator PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (DistanceCompensator PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (DistanceCompensator PRIVATE Source)

target_link_libraries (DistanceCompensator PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== DualDelay/CMakeLists.txt ===

juce_add_plugin (DualDelay
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE DuDe
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "DualDelay"
    FORMATS ${IEM_FORMATS}
    VERSION "0.5.1")


juce_generate_juce_header (DualDelay)

target_sources (DualDelay PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (DualDelay PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (DualDelay PRIVATE Source)

target_link_libraries (DualDelay PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== EnergyVisualizer/CMakeLists.txt ===

juce_add_plugin (EnergyVisualizer
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE EnVi
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "EnergyVisualizer"
    FORMATS ${IEM_FORMATS}
    VERSION "1.0.3")


juce_generate_juce_header (EnergyVisualizer)

target_sources (EnergyVisualizer PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (EnergyVisualizer PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (EnergyVisualizer PRIVATE Source)

target_link_libraries (EnergyVisualizer PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== FdnReverb/CMakeLists.txt ===

juce_add_plugin (FdnReverb
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE FdRe
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "FdnReverb"
    FORMATS ${IEM_FORMATS}
    VERSION "1.2.3")


juce_generate_juce_header (FdnReverb)

target_sources (FdnReverb PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (FdnReverb PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (FdnReverb PRIVATE Source)

target_link_libraries (FdnReverb PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== MatrixMultiplier/CMakeLists.txt ===

juce_add_plugin (MatrixMultiplier
    PLUGIN_MANUFACTURER_CODE IEMA
    PLUGIN_CODE MaMu
    ICON_BIG "../resources/Standalone/IEMPluginSuiteSmall.png"
    ICON_SMALL "../resources/Standalone/IEMPluginSuiteSmall.png"
    COMPANY_NAME "IEM"
    PRODUCT_NAME "MatrixMultiplier"
    FORMATS ${IEM_FORMATS}
    VERSION "0.3.3")


juce_generate_juce_header (MatrixMultiplier)

target_sources (MatrixMultiplier PRIVATE
    Source/PluginEditor.cpp
    Source/PluginEditor.h
    Source/PluginProcessor.cpp
    Source/PluginProcessor.h

    ../resources/OSC/OSCInputStream.h
    ../resources/OSC/OSCParameterInterface.cpp
    ../resources/OSC/OSCParameterInterface.h
    ../resources/OSC/OSCStatus.cpp
    ../resources/OSC/OSCStatus.h
    ../resources/OSC/OSCUtilities.h

    ../resources/efficientSHvanilla.cpp
    )

target_compile_definitions (MatrixMultiplier PRIVATE
    JUCE_USE_CURL=0
    JUCE_WEB_BROWSER=0
    JUCE_USE_CUSTOM_PLUGIN_STANDALONE_APP=1
    JUCE_DISPLAY_SPLASH_SCREEN=0
    JUCE_VST3_CAN_REPLACE_VST2=0)

target_include_directories (MatrixMultiplier PRIVATE Source)

target_link_libraries (MatrixMultiplier PRIVATE
    LAF_fonts
    juce::juce_audio_utils
    juce::juce_audio_plugin_client
    juce::juce_osc
    juce::juce_dsp
    juce::juce_opengl
    juce::juce_recommended_config_flags
    juce::juce_recommended_lto_flags)

=== debian/changelog ===
iem-plugin-suite (1.13.0-2) unstable; urgency=medium

  * Provide virtual package "vst-plugin"
  * Rebuild against juce-6.1.5

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 08 Feb 2022 19:52:10 +0100

iem-plugin-suite (1.13.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 23 Dec 2021 13:00:48 +0100

iem-plugin-suite (1.13.0-1~exp1) experimental; urgency=medium

  * New upstream version 1.13.0
    * Drop patch applied upstream
    * Backport upstream fixes
  * Use CMake instead of Projucer to build
    * Don't build VST3
  * Drop "Files-Excluded: .git*" from d/copyright
  * Apply 'wrap-and-sort -ast'
  * d/copyright: Trimmed away unused licenses
  * Bump standards version to 4.6.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 17 Dec 2021 10:21:54 +0100

iem-plugin-suite (1.12.0-1~exp1) experimental; urgency=medium

  * New upstream version 1.12.0
  * Adjust for JUCE-6.1.0
  * Refresh d/copyright
    * Regenerate d/copyright_hints
  * Bump dh-compat to 13
    * Don't manually create symlinks (use *.links for that)
  * Bump standards version to 4.5.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 30 Aug 2021 15:15:58 +0200

=== debian/control ===
Source: iem-plugin-suite
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-exec,
 juce-modules-source (>= 6.1.3~),
 juce-tools (>= 6.1.3~),
 libasound2-dev,
 libcurl4-gnutls-dev | libcurl-dev,
 libfftw3-dev,
 libfreetype6-dev,
 libgl1-mesa-dev | libgl-dev,
 libjack-dev,
 libjpeg-dev,
 libpng-dev,
 libx11-dev,
 libxext-dev,
 libxinerama-dev,
 libxrandr-dev,
 zlib1g-dev | libz-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://plugins.iem.at/
Vcs-Git: https://salsa.debian.org/multimedia-team/iem-plugin-suite.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/iem-plugin-suite

Package: iem-plugin-suite-vst
Architecture: any
Built-Using:
 ${juce:BuiltUsing},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 vst-plugin,
Description: IEM's spatialization suite - VST2 plugins
 The IEM Plug-in Suite is an audio plugin suite created at the Institute of
 Electronic Music and Acoustics (Graz, Austria).
 It features Higher-Order Ambisonic plug-ins (up to 7th order), among them a
 number of state of the art encoders, directional compressors, directivity
 shapers, delay and reverb effects and analysis tools.
 .
 This package provides the plugins so they can be used by VST2 hosts.

Package: iem-plugin-suite-standalone
Architecture: any
Built-Using:
 ${juce:BuiltUsing},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: IEM's spatialization suite - standalone
 The IEM Plug-in Suite is an audio plugin suite created at the Institute of
 Electronic Music and Acoustics (Graz, Austria).
 It features Higher-Order Ambisonic plug-ins (up to 7th order), among them a
 number of state of the art encoders, directional compressors, directivity
 shapers, delay and reverb effects and analysis tools.
 .
 This package provides the plugins as standalone applications.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
export DEB_CPPFLAGS_MAINT_APPEND  = -DJUCE_JACK=1 -DJUCE_MODAL_LOOPS_PERMITTED=1
export DEB_LDFLAGS_MAINT_APPEND =

# iem-plugin-suite uses some c++11 features requiring atomic_store_8 and
# atomic_load_8, so we need to link with libatomic on
# armel, powerpc, powerpcspe, m68k, mips, mipsel, and sh4
# see also:
# - https://gcc.gnu.org/wiki/Atomic
# - https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
# - the 'clasp' packaging
noatomicarch = $(shell dpkg-architecture -qDEB_HOST_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4)")

# link with libatomic on architectures without built-in atomic
ifeq ($(if $(noatomicarch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

JUCE_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' juce-modules-source)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DIEM_USE_SYSTEM_JUCE=ON \
		-DIEM_BUILD_STANDALONE=ON \
		-DIEM_BUILD_VST2=ON \
		-DIEM_BUILD_VST3=OFF \
		-DVST2SDKPATH=/usr/include \
		$(empty)

execute_before_dh_install:
	# install the VST plugins and the standalong applications
	find $(CURDIR) -type f -executable -path "*_artefacts/*" -path "*/Standalone/*" -print0 | xargs -r0 ./debian/install.sh

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.md


override_dh_gencontrol:
	dh_gencontrol -- \
                -Vjuce:BuiltUsing="juce ( = $(JUCE_VERSION) )"


execute_after_dh_clean:
	rm -rf _man _vst _bin

licensecheck:
	licensecheck --deb-machine -r * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints
